//+------------------------------------------------------------------+
//|                                                     raysbars.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#include <stderror.mqh>
#include <stdlib.mqh>


  extern double dlots=0.1;
  extern double iStopLoss=20;
  extern double iTakeProfit=20;
  extern int iSlippage=3;
  extern int iMaxTrades=1;
  extern int iMagicNumber=1400;

  int iTradeSignal=0;
  int iOpenBuySignal=100;
  int iCloseBuySignal=-200;
  int iOpenSellSignal=300;
  int iCloseSellSignal=-400;
  int iNoSignal=-1;
  
  int ilastTradeType;
  int iTotalTrades;
  int iTotalSelectedTrades;
  int iTotalBuyTrades;
  int iTotalSellTrades;
  int ilastTradeOpenTime;
  
 
  bool bOrderCloseStatus;

  double dTotalTradelots;
  double dTotalTradeSwap;
  double dTotalOpenProfit;

  double dlastTradeOpenPrice;
  double dlastTradeStoploss;
  double dlastTradeTakeProfit;
  double dlastTradeType;
  double dlastTradeTicket;

  string strLastTradeSymbol;
  string strLastTradeComment;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+

 int init()
  {
//----
//    iTotalTrades=1 
//----
   return(0);
  }
 
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+

  int deinit()
  {
   return(0);
  }
  
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+

int start()
  {
         Print( "       Start   " );

//-----------------------------  
  fnGetOpenTradeInfo();
//    bool fnNewBar();
  fnOpenBuyLogic();
  fnOpenSellLogic();
  fnCloseBuyLogic();
  fnCloseSellLogic();
   fnOpenOrders();
  fnCloseOrders();
     
//-----------------------------
   return(0);
  }
//+------------------------------------------------------------------+

 void fnGetOpenTradeInfo()
  {
         Print( "    1st    function call   " );

     dTotalOpenProfit=0;
     dTotalTradelots =0;
     iTotalBuyTrades=0;
     iTotalSellTrades=0;
     dTotalTradeSwap=0;
     iTotalSelectedTrades=0;
     iTotalTrades=OrdersTotal();
     
     for(int pos=OrdersTotal()-1; pos>=0; pos--)
      {
   
      if(OrderSelect(pos, SELECT_BY_POS,MODE_TRADES)
       && OrderSymbol() == Symbol()
       && OrderMagicNumber() == iMagicNumber ) 
        {
 
       iTotalSelectedTrades++;            
       dTotalOpenProfit += OrderProfit();
       dTotalTradeSwap += OrderSwap();
       dTotalTradelots += OrderLots();
       
       if( OrderType() == OP_BUY )
        {
         iTotalBuyTrades++; 
         ilastTradeType = OP_BUY;
      }   
      
      if( OrderType() == OP_SELL )
        {
         iTotalSellTrades++; 
         ilastTradeType = OP_SELL;
      }
     }
    }
   }
  
//========================================

//+---------------------------------------------------   
//----------    Det new Bar 
//+---------------------------------------------------

/*   bool NewBar()
     {
      int NewBar1;   
   static datetime lastbar;
   datetime curbar = Time[0];
   if(lastbar!=curbar)
   {
      lastbar=curbar;
       NewBar1++;
     Alert("New bar just Exist."); 
 }
*/
//      return (true);
//   }
//   else
//   {
//      return(false);
//   }
// }  
  

 void fnOpenBuyLogic()
     {
         Print( "    Buy-logic    Close1  Open1   " );
        
      if ( Ask>Close[1] )          
        {  
         iTradeSignal = iOpenBuySignal;
//         Alert("  BUY SIGNAL   iOpenBuySignal; ",iOpenBuySignal);   
     }
     }
//    }
//   }
   
  
//========================================
      
  void fnOpenSellLogic()
     {
          
         Print( "    Sell-logic    Close1  Open1   " );
        
      if ( Bid<Close[1])          
        {  
         iTradeSignal = iOpenSellSignal;
//         Alert("  SELL SIGNAL   iOpenSellSignal; ",iOpenSellSignal);   
     }
     }
//    }
//    }
    
 
//==========================================

  void fnCloseBuyLogic()
    {
     int NewBar;
//   if ( NewBar==4)
//      iTradeSignal=iCloseBuySignal;
     
     }    
//==========================================
    
  void fnCloseSellLogic()
     {
     int NewBar;
//   if ( NewBar==4 )
//      iTradeSignal=iCloseSellSignal;
    }


//+---------------------------------------------------   
//----------    Det new Bar 
//+---------------------------------------------------
   
/*  bool Function_New_Bar()
    {
     double New_Time;
     int f_New_Time,NewBar;
     bool f_New_Bar = false;
     if (New_Time!=Time[0])
      {
      New_Time = Time[0];
     f_New_Bar = true;
       NewBar++;
      
     Alert(Time[0]);
     }
     return(f_New_Bar);
 
  

    if (f_New_Bar==false){
      Alert("Waiting for new bar");
       }else{
       Alert("New bar just Exist."); 
     }
    }
*/

//+---------------------------------------------
//                  Open Buy      
//+---------------------------------------------

  
 void fnOpenOrders() 
     { 
     int iOrderOpenStatus;
     string strErrorMessage;
     int iErrorNumber;
     bool bOrdercloseStatus;
  
     if ( iTradeSignal == iOpenBuySignal &&  iTotalSelectedTrades<=iMaxTrades )
          {   
//          double dBuyStopLoss=20;
//          double dBuyTakeProfit=20;
             int NewBar=0;

     iOrderOpenStatus = OrderSend(Symbol(),OP_BUY,dlots,Bid,iSlippage,iStopLoss,iTakeProfit,"RaysBar",iMagicNumber,0,Blue);
          
        if( iOrderOpenStatus < 0)
            {
            iErrorNumber = GetLastError();
            strErrorMessage = ErrorDescription(iErrorNumber);
            Print( "Ordersend Failed: ", strErrorMessage );
          }
         return;
      }
 
 //+-------------------- Open Sell ------------------------+ 
  
     if( iTradeSignal == iOpenSellSignal && iTotalSelectedTrades<=iMaxTrades )
        {        
//          double dSellStopLoss=20;
//            double dSellTakeProfit=20;
               NewBar=0;
              
    iOrderOpenStatus = OrderSend(Symbol(),OP_SELL,dlots,Ask,iSlippage,iStopLoss,iTakeProfit,"RaysBar",iMagicNumber,0,Red);    

        if( iOrderOpenStatus < 0)
           {
            iErrorNumber = GetLastError();
            strErrorMessage = ErrorDescription(iErrorNumber);
            Print( "Ordersend Failed: ", strErrorMessage );
          }
          }
          return;
        }
       
         
   //+-------------------------------------------
   //        Close Buy/Sell  
   //+------------------------------------------- 
  
  
 void fnCloseOrders()
       {
     int iOrderOpenStatus;
     string strErrorMessage;
     int iErrorNumber;
     bool bOrdercloseStatus;
  
     if ( iTradeSignal == iCloseBuySignal || iTradeSignal == iCloseSellSignal )
         {  
     for(int pos=OrdersTotal()-1; pos>=0; pos--)
          {
        if(OrderSelect(pos,SELECT_BY_POS,MODE_TRADES)
         && OrderSymbol() == Symbol()
         && OrderMagicNumber() == iMagicNumber )
           {
//+--------------------------------------------
//                        Close Buy
//+-------------------------------------------- 
        if(OrderType() == OP_BUY )
            {
          bOrderCloseStatus = OrderClose( OrderTicket(), OrderLots(), Bid, iSlippage, Red );
     
           if ( bOrderCloseStatus == false )
            {  
            iErrorNumber = GetLastError();
            strErrorMessage = ErrorDescription(iErrorNumber);
            Print( "OrderClose Failed: ", strErrorMessage );     
            }
          return;
        }
      
//+--------------------------------------------
//                    Close Sell
//+-------------------------------------------- 
    
      if( OrderType() == OP_SELL )
         {
        bOrderCloseStatus = OrderClose( OrderTicket(), OrderLots(), Bid, iSlippage, Red );
   
         if( bOrderCloseStatus == false )
            { 
            iErrorNumber = GetLastError();
            strErrorMessage = ErrorDescription(iErrorNumber);
            Print( "OrderClose Failed: ", strErrorMessage );
       }
      }   
          return;
         }  
        }             
       } 
      }
   
 